package higa.dbswing;

//import com.sun.java.swing.JRadioButton;
//import com.sun.java.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;

import java.io.Serializable;

import higa.sql.dataset.IDataSet;
import higa.sql.dataset.CheckAware;

public class HJRadioButton extends JRadioButton
  implements CheckAware, Serializable {

  private transient boolean addNotifyCalled = false;

  public HJRadioButton() {
    setModel(new HButtonModel());
  }

  public void setDataSet(IDataSet newDataSet) {
    ((HButtonModel)getModel()).setDataSet(newDataSet);
  }

  public IDataSet getDataSet() {
    return ((HButtonModel)getModel()).getDataSet();
  }

  public void setColumnName(String newColumnName) {
    ((HButtonModel)getModel()).setColumnName(
      newColumnName);

    if (addNotifyCalled) {
      openDataSet();
    }
  }

  public String getColumnName() {
    return ((HButtonModel)getModel()).getColumnName();
  }

  public void setCheckValue(String newCheckValue) {
    ((HButtonModel)getModel()).setCheckValue(newCheckValue);
    if (addNotifyCalled) {
      openDataSet();
    }
  }

  public String getCheckValue() {
    return ((HButtonModel)getModel()).getCheckValue();
  }

  public void setUncheckValue(String newUncheckValue) {
    ((HButtonModel)getModel()).setUncheckValue(
      newUncheckValue);

    if (addNotifyCalled) {
      openDataSet();
    }
  }

  public String getUncheckValue() {
    return ((HButtonModel)getModel()).getUncheckValue();
  }

  public void setGroup(ButtonGroup newButtonGroup) {
    getModel().setGroup(newButtonGroup);
    if (addNotifyCalled) {
      openDataSet();
    }
  }

  public ButtonGroup getGroup() {
    return ((HButtonModel)getModel()).getGroup();
  }

  public void addNotify() {
    super.addNotify();
    if (!addNotifyCalled) {
      addNotifyCalled = true;
      openDataSet();
    }
  }

  private void openDataSet() {
    IDataSet dataSet = getDataSet();
    if (dataSet == null || !addNotifyCalled) {
      return;
    }

    if (!dataSet.isOpen()) {
      try {
        dataSet.open();
      } catch (Exception ex) {
        ex.printStackTrace();
        return;
      }
    }

    if (dataSet.isOpen()) {
      ((HButtonModel)getModel()).updateState();
      repaint();
    }
  }
}