package higa.dbswing;

import java.io.Serializable;

//import com.sun.java.swing.table.AbstractTableModel;
import javax.swing.table.AbstractTableModel;

import higa.sql.dataset.IDataSet;
import higa.sql.dataset.DataChangeEvent;
import higa.sql.dataset.DataChangeListener;
import higa.sql.dataset.Status;

import higa.util.JDBCUtil;

public class HTableModel extends AbstractTableModel
  implements DataChangeListener {

  private IDataSet dataSet;

  public HTableModel() {}

  public HTableModel(IDataSet ds) {
    setDataSet(ds);
  }

  public void setDataSet(IDataSet ds) {
    if (dataSet != null) {
      dataSet.removeDataChangeListener(this);
    }

    dataSet = ds;

    if (dataSet != null) {
      dataSet.addDataChangeListener(this);
    }
  }

  public int getRowCount() {
    return dataSet.getRowCount();
  }

  public int getColumnCount() {
    return dataSet.getColumnCount();
  }

  public String getColumnName(int columnIndex) {
    return dataSet.getColumnName(columnIndex);
  }

  public Class getColumnClass(int columnIndex) { return String.class; }

  public boolean isCellEditable(
    int rowIndex, int columnIndex) {

    return true;
  }

  public Object getValueAt(int rowIndex, int columnIndex) {
    return dataSet.get(rowIndex, columnIndex);
  }

  public void setValueAt(Object value,
    int rowIndex, int columnIndex) {

    try {
      dataSet.set(rowIndex, columnIndex, value);
    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public void dataChanged(DataChangeEvent e) {
    int rowIndex = dataSet.getRowIndex();
    switch(e.getStatus()) {
      case Status.INSERTED:
        fireTableRowsInserted(rowIndex, rowIndex);
        break;
      case Status.DELETED:
        fireTableRowsDeleted(rowIndex, rowIndex);
        break;
      case Status.UPDATED:
        fireTableRowsUpdated(rowIndex, rowIndex);
        break;
      default:
        fireTableDataChanged();
    }
  }
}