package higa.jhcl.model;

public interface MatrixSelection {

  void set(MatrixLocation[] locations);

  void add(MatrixLocation location);

  void add(int rowIndex, int columnIndex);

  void add(MatrixLocation[] locations);

  void addRange(MatrixLocation begin, MatrixLocation end);

  void addRange(int beginRowIndex, int beginColumnIndex,
    int endRowIndex, int endColumnIndex);

  void remove(MatrixLocation location);

  void remove(int rowIndex, int columnIndex);

  void remove(MatrixLocation[] locations);

  void removeRange(MatrixLocation begin, MatrixLocation end);

  void removeRange(int beginRowIndex, int beginColumnIndex,
    int endRowIndex, int endColumnIndex);

  void removeAll();

  void setEventEnabled(boolean enable);

  boolean contains(MatrixLocation location);

  boolean contains(int rowIndex, int columnIndex);

  int getCount();

  MatrixLocation[] getAll();

  void addSelectionListener(
    MatrixSelectionListener listener);

  void removeSelectionListener(
    MatrixSelectionListener listener);
}