package higa.jhcl.model;

import java.util.EventListener;

public class MatrixSelectionEvent extends SelectionEvent {

  private MatrixLocation  location;
  private MatrixLocation  rangeStart;
  private MatrixLocation  rangeEnd;

  public MatrixSelectionEvent(MatrixSelection selection,
    int change) {

    super(selection, change);
  }

  public MatrixSelectionEvent(MatrixSelection selection,
    int change, MatrixLocation location) {

    this(selection, change);
    this.rangeStart = this.rangeEnd = this.location = location;
  }

  public MatrixSelectionEvent(MatrixSelection selection,
    int change, MatrixLocation rangeStart,
    MatrixLocation rangeEnd) {

    this(selection, change);
    this.location = this.rangeStart = rangeStart;
    this.rangeEnd = rangeEnd;
  }

  public MatrixLocation getLocation() {
    return location;
  }

  public MatrixLocation getRangeStart() {
    return rangeStart;
  }

  public MatrixLocation getRangeEnd() {
    return rangeEnd;
  }

  public void dispatch(EventListener listener) {
    MatrixSelectionListener myListener =
      (MatrixSelectionListener)listener;

    switch (getID()) {
      case ITEM_CHANGE:
        myListener.selectionItemChanged(this);
        break;
      case RANGE_CHANGE:
        myListener.selectionRangeChanged(this);
        break;
      case SELECTION_CHANGE:
        myListener.selectionChanged(this);
        break;
      default:
        throw new Error("ID:" + getID());
    }
  }
}