package higa.jhcl.model;

import java.util.EventListener;

import higa.util.VetoableDispatch;
import higa.util.VetoException;

public class MatrixSubfocusEvent extends SubfocusEvent
  implements VetoableDispatch {
  
  private MatrixLocation location;

  public MatrixSubfocusEvent(Object source, int id,
    MatrixLocation location) {

    super(source, id);
    this.location = new MatrixLocation(location);
  }

  public MatrixLocation getLocation() {
    return location;
  }

  public void vetoableDispatch(EventListener listener)
    throws VetoException {

    MatrixSubfocusListener myListener =
      (MatrixSubfocusListener)listener;

    switch (getID()) {
      case SUBFOCUS_CHANGING:
        myListener.subfocusChanging(this);
        break;
      default:
        throw new IllegalStateException("ID:" + getID());
    }
  }

  public void dispatch(EventListener listener) {
    MatrixSubfocusListener myListener =
      (MatrixSubfocusListener)listener;

    switch (getID()) {
      case SUBFOCUS_CHANGED:
        myListener.subfocusChanged(this);
        break;
      default:
        throw new IllegalStateException("ID:" + getID());
    }
  }
}