package higa.jhcl.model;

import java.util.EventListener;

public class VectorModelEvent extends ModelEvent {

  public static final int ITEM_CHANGED =
    CONTENT_CHANGED | 0x0010;

  public static final int ITEM_ADDED =
    STRUCTURE_CHANGED | 0x0010;

  public static final int ITEM_REMOVED =
    STRUCTURE_CHANGED | 0x0020;

  private int location;

  public VectorModelEvent(VectorModel model, int change) {
    super(model, change);
  }

  public VectorModelEvent(VectorModel model,
    int change, int location) {

    this(model, change);
    this.location = location;
  }

  public int getLocation() {
    return location;
  }

  public void dispatch(EventListener listener) {
    VectorModelListener myListener =
      (VectorModelListener)listener;

    switch (getID()) {
      case CONTENT_CHANGED:
        myListener.modelContentChanged(this);
        break;
      case STRUCTURE_CHANGED:
        myListener.modelStructureChanged(this);
        break;
      default:
        throw new IllegalStateException("ID:" + getID());
    }
  }
}