package higa.jhcl.view;

import java.io.Serializable;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Insets;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Component;
import java.awt.AWTEvent;

import java.awt.event.MouseEvent;

import java.util.Date;

import higa.jhcl.model.ItemPainter;
import higa.jhcl.model.ItemEditor;
import higa.jhcl.model.ItemPaintSite;
import higa.jhcl.model.ItemEditSite;

import higa.dbawt.HChoice;

public class ChoiceItemPainterEditor
  extends HChoice
  implements ItemPainter, ItemEditor,
  Serializable {

  private ItemPainter painter = new FocusableItemPainter(
      new SelectableItemPainter(new TextItemPainter()));

  public ChoiceItemPainterEditor() {
    setBounds(0,0,0,0);
    setVisible(false);
  }

  public Dimension getPreferredSize(
    Object data, Graphics g,
    int state, ItemPaintSite site) {

    return painter.getPreferredSize(
      getItemByValue(data), g, state, site);
  }

  public void paint(Object data, Graphics g,
    Rectangle bounds, int state, ItemPaintSite site) {

    painter.paint(
      getItemByValue(data), g, bounds, state, site);
  }

  public Object getValue() {
    String item = getSelectedItem();
    return getItemValue(item);
  }

  public Component getComponent() {
    return this;
  }

  public void startEdit(Object data, Rectangle bounds,
    ItemEditSite site) {

    String item = getItemByValue(data);
    select(item);
    setBounds(bounds.x, bounds.y,
      bounds.width, bounds.height);

    if (site != null) {
      setBackground(site.getBackground());
      setForeground(site.getForeground());
      setFont(site.getFont());
    }

    setVisible(true);
    requestFocus();
  }

  public void endEdit(boolean post) {
    setBounds(0,0,0,0);
    setVisible(false);
  }

  protected void updateColumn() {}
}