package higa.jhcl.view;

import java.util.EventListener;

import higa.util.BasicEvent;
import higa.util.Dispatch;

public class HeaderEvent extends BasicEvent
  implements Dispatch {

  public static final int ITEM_CLICKED = 0;
  public static final int START_RESIZE = 1;
  public static final int WHILE_RESIZE = 2;
  public static final int STOP_RESIZE  = 3;

  private int id;
  private int index;
  private int x;
  private int y;

  public HeaderEvent(Object source,
    int id, int index, int x, int y) {

    super(source, id);
    this.index  = index;
    this.x      = x;
    this.y      = y;
  }

  public void dispatch(EventListener listener) {
    switch (getID()) {
      case ITEM_CLICKED:
        ((HeaderListener)listener).headerItemClicked(this);
        break;
      case START_RESIZE:
      case WHILE_RESIZE:
      case STOP_RESIZE:
        ((HeaderListener)listener).headerItemResizing(this);
        break;
      default:
        throw new IllegalStateException("ID:" + getID());
    }
  }

  public int getIndex() {
    return index;
  }

  public int getX() {
    return x;
  }

  public int getY() {
    return y;
  }
}