package higa.sql.dataset;

import java.sql.SQLException;

public interface IDataSet {

  public void insertRow() throws SQLException;

  public void insertRow(int rowIndex) throws SQLException;

  public void set(String columnName, Object value)
    throws SQLException ;

  public void set(int rowIndex, int columnIndex,
    Object value) throws SQLException ;

  public void deleteRow() throws SQLException;

  public void deleteRow(int rowIndex) throws SQLException;

  public void post() throws SQLException;

  public void cancel() throws SQLException;

  public void commit() throws SQLException;

  public void rollback() throws SQLException;

  public void open() throws SQLException;

  public boolean isOpen();

  public boolean isFirst();

  public boolean isLast();

  public boolean isEditing();

  public boolean isTransaction();

  public boolean isEmpty();

  public Object get(String columnName);

  public Object get(int columnIndex);

  public Object get(int rowIndex, int columnIndex);

  public String getString(String columnName);

  public String getString(int columnIndex);

  public String getColumnName(int columnIndex);

  public Column getColumn(String columnName);

  public Column getColumn(int columnIndex);

  public int getColumnCount();

  public int getRowCount();

  public int getStatus();

  public int getRowIndex();

  public int getRowid();

  public HDatabase getDatabase();

  public boolean next() throws SQLException;

  public boolean prior() throws SQLException;

  public boolean first() throws SQLException;

  public boolean last() throws SQLException;

  public boolean goToRow(int rowIndex) throws SQLException;

  public void setMasterDataSet(IDataSet ds);

  public IDataSet getMasterDataSet();

  public void setMasterColumnNames(
    String[] masterColumns);

  public String[] getMasterColumnNames();

  public void setDetailColumnNames(
    String[] detailColumns);

  public String[] getDetailColumnNames();

  public void addDataChangeListener(
    DataChangeListener listener);

  public void removeDataChangeListener(
    DataChangeListener listener);

  public void addNavigationListener(
    NavigationListener listener);

  public void removeNavigationListener(
    NavigationListener listener);

  public void addMasterDataChangeListener(
    MasterDataChangeListener listener);

  public void removeMasterDataChangeListener(
    MasterDataChangeListener listener);

  public void addStatusListener(
    StatusListener listener);

  public void removeStatusListener(
    StatusListener listener);
}